const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const app_accounts = sequelize.define(
    'app_accounts',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      role: {
        type: DataTypes.ENUM,

        values: ['User', 'Admin', 'SuperAdmin'],
      },

      status: {
        type: DataTypes.ENUM,

        values: ['Active', 'Inactive'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  app_accounts.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.app_accounts.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.app_accounts.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.app_accounts.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.app_accounts.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return app_accounts;
};
